unit vgtest1;

{VGTEST1.PAS (c) 1998 Business Software ebinfo@compuserve.com}
{This program is supplied with the VGRID {bsvgrid) component (c)1998 Business Software}
{for evaluation purposes. It may not be distributed in compiled or uncompiled form without}
{the associated files in the distribution package.}
{This program is provided subject to the terms and conditions included with the package.}
{If you do not have text (*.txt) files containing Terms and Conditions,
{then this package is incomplete. Please contact Business Software for the full package}

{The purpose of this program is to demonstrate some of the features of the BSVGRID}
{component as used in a simple database program. It is assumed that you have Delphi installed,}
{and the DBDEMOS BDE alias is set up as per the default installation. The program uses}
{two BSVGRIDs, and a normal DBGRID, together with the usual data access components.}
{Part of the program shows you how to 'float' controls over the grid, using some of BSVGRID's}
{novel properties, such as FIELDRECT, FIELDSTR, BUTTONDOWN, etc}
{BSVGRID lets you build fairly sophisticated data-entry screens with little or no programming}

{NOTE THAT THE SHAREWARE EVALUATION BSVGRID COMPONENT CAN ONLY FUNCTION WHILST THE DELPHI}
{IDE IS RUNNING. IF THIS PACKAGE DOES NOT CONTAIN FILE BSVGRID1.PAS, THEN YOU HAVE THE
{EVALUATION PACKAGE. THE FULL PACKAGE INCLUDING SOURCE CODE IS AVAILABLE UPON PAYMENT}
{OF THE REGISTRATION FEE. SEE THE TEXT FILES DISTRIBUTED WITH THIS PACKAGE FOR INSTRUCTIONS}
{FOR REGISTERING ON-LINE. ALTERNATIVELY, SEE OUR WEB PAGE AT HTTP://MEMBERS.XOOM.COM/BSOFT/}

{ALL DOCUMENTATION, HELP FILES, TEXT FILES, PROGRAM FILES, AND INTELLECTUAL PROPERTY IS THE}
{COPYRIGHT OF BUSINESS SOFTWARE, PROTECTED UNDER INTERNATIONAL LAW. ALL RIGHTS RESERVED}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables, Grids, ExtCtrls, DBCtrls, bsvgrid1,
  DBGrids, Mask, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    Panel1: TPanel;
    Panel2: TPanel;

    Table1LAST_NAME: TStringField;
    Table1FIRST_NAME: TStringField;
    Table1ACCT_NBR: TFloatField;
    Table1ADDRESS_1: TStringField;
    Table1CITY: TStringField;
    Table1STATE: TStringField;
    Table1ZIP: TStringField;
    Table1TELEPHONE: TStringField;
    Table1DATE_OPEN: TDateField;
    Table1SS_NUMBER: TFloatField;
    Table1BIRTH_DATE: TDateField;
    Table1RISK_LEVEL: TStringField;
    Table1OCCUPATION: TStringField;
    Table1OBJECTIVES: TStringField;
    Table1INTERESTS: TStringField;
    Table1IMAGE: TBlobField;
    DBImage1: TDBImage;
    Panel3: TPanel;

    Table2: TTable;
    DataSource2: TDataSource;
    Table3: TTable;
    DataSource3: TDataSource;
    Table2SYMBOL: TStringField;
    Table2SHARES: TFloatField;
    Table2PUR_PRICE: TFloatField;
    Table2PUR_DATE: TDateField;
    Table2ACCT_NBR: TFloatField;
    Table2Investment: TCurrencyField;
    Table3SYMBOL: TStringField;
    Table3CO_NAME: TStringField;
    Table3EXCHANGE: TStringField;
    Table3CUR_PRICE: TFloatField;
    Table3YRL_HIGH: TFloatField;
    Table3YRL_LOW: TFloatField;
    Table3P_E_RATIO: TFloatField;
    Table3BETA: TFloatField;
    Table3PROJ_GRTH: TFloatField;
    Table3INDUSTRY: TSmallintField;
    Table3PRICE_CHG: TSmallintField;
    Table3SAFETY: TSmallintField;
    Table3RATING: TStringField;
    Table3RANK: TFloatField;
    Table3OUTLOOK: TSmallintField;
    Table3RCMNDATION: TStringField;
    Table3RISK: TStringField;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Panel5: TPanel;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    DBNavigator1: TDBNavigator;
    Label2: TLabel;
    Table4: TTable;
    Combo1: TComboBox;
    Pop1: TPopupMenu;
    NewClient1: TMenuItem;
    N1: TMenuItem;
    Hover1: TMenuItem;
    BSVgrid1: TBSVgrid;
    BSVgrid2: TBSVgrid;
    procedure BSVgrid1Click(Sender: TObject);
    procedure BSVgrid1ButtonDown(Sender: TObject);
    procedure Table2CalcFields(DataSet: TDataSet);
    procedure FormActivate(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure DataSource3DataChange(Sender: TObject; Field: TField);
    procedure BSVgrid1TopLeftChanged(Sender: TObject);
    procedure Combo1Change(Sender: TObject);
    procedure Hover1Click(Sender: TObject);
    procedure Pop1Popup(Sender: TObject);
    procedure NewClient1Click(Sender: TObject);
  private
    { Private declarations }
    procedure investsum;
    procedure showcombo(fldname:string;p:TPoint;w:integer);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.BSVgrid1Click(Sender: TObject);
begin
if (combo1.visible) then combo1.hide;
end;

{this procedure illustrates the use of buttons with BSVGRID
fields. Buttons are created automatically when a field's TAG property is set below zero.
Clicking the button with the mouse triggers an OnButtonDown event for the BSVGrid.
the SELECTEDINDEX property signals the row(field number (zero-based) that contains the
triggered button. }
procedure TForm1.BSVgrid1ButtonDown(Sender: TObject);
var
s:string;
p:Tpoint;
w:integer;
begin
s:=table1.fields[bsvgrid1.selectedindex].fieldname;
p:=bsvgrid1.parent.screentoclient(bsvgrid1.fieldrect.topleft);
w:=bsvgrid1.fieldrect.right-bsvgrid1.fieldrect.left;
showcombo(s,p,w);
end;

{position and fill combobox}
procedure Tform1.showcombo(fldname:string;p:TPoint;w:integer);
const
IObjectives:array[0..2] of string=('Growth','Income','Retirement');
IRisk:array[0..2] of string=('Low','Med','High');
var
i:integer;
begin
with combo1 do
 begin
 items.clear;
 if (fldname='OBJECTIVES') then for i:=0 to high(iobjectives) do combo1.items.add(iobjectives[i]);
 if (fldname='RISK_LEVEL') then for i:=0 to high(irisk) do combo1.items.add(irisk[i]);
 itemindex:=items.indexof(bsvgrid1.fieldstr);
 left:=p.x;
 top:=p.y;
 width:=w;
 visible:=true;
 end;
end;

procedure TForm1.BSVgrid1TopLeftChanged(Sender: TObject);
begin
if (combo1.visible) then combo1.hide;
end;

{write-back changes using FIELDSTR property}
procedure TForm1.Combo1Change(Sender: TObject);
begin
bsvgrid1.fieldstr:=combo1.text;
end;


{cosmetic}
procedure TForm1.Table2CalcFields(DataSet: TDataSet);
begin
table2investment.value:=table2shares.value*table2pur_price.value;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
label1.caption:='  Portfolio:'+table1first_name.value+' '+table1last_name.value;
label5.caption:='  Company:'+table3symbol.value+'-'+table3co_name.value;
investsum;
end;


procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
label1.caption:='  Portfolio:'+table1first_name.value+' '+table1last_name.value;
investsum;
end;

procedure TForm1.DataSource3DataChange(Sender: TObject; Field: TField);
begin
label5.caption:='  Company:'+table3symbol.value+'-'+table3co_name.value;
end;

{calc total investment}
procedure tform1.investsum;
var x:double;
begin
x:=0;
if not table2.active then exit;
table2.disablecontrols;
table2.first;
while not table2.eof do
  begin
  x:=x+(table2shares.value*table2pur_price.value);
  table2.next;
  end;
table2.first;
table2.enablecontrols;
label2.caption:='  Sum Invested: $'+floattostrf(x,fffixed,15,2)+'      ';
end;

{pop-up menu}
procedure TForm1.Pop1Popup(Sender: TObject);
begin
hover1.checked:=(activecontrol as Tbsvgrid).hover;
newclient1.enabled:=(activecontrol=bsvgrid1);
end;

procedure TForm1.Hover1Click(Sender: TObject);
begin
hover1.checked:=not hover1.checked;
(activecontrol as TBSVGRID).hover:=hover1.checked;
end;


procedure TForm1.NewClient1Click(Sender: TObject);
begin
Table1.append;
end;

end.

